//  dllobject.h
// example DLL OBJECT, (c) Stewart N. Johnston, Sept. 9, 1993

#ifndef DLLOBJECT_H
#define DLLOBJECT_H

#include<windows.h>

#define Max_DLL_Name 80
#define Error_Code  -1
#define Success_Object_Construction 1


typedef unsigned long ULONG;
typedef void far* (FAR PASCAL _export *CONSTRUCTOR)(UINT message,
				WPARAM wParam,LPARAM lParam);
typedef long (FAR PASCAL _export *MESSAFUNCTION)(void far *xxthis,
				UINT message,WPARAM wParam,LPARAM lParam);
typedef void (FAR PASCAL _export *DESTRUCTOR)(void far *xxthis);

/*

	The DLLobject class will load and create an instance of a DLL class.
	See (project dllclass.prj file dlllib.cpp) for class interface.
	This class will allow you to load and create as many instances
	of many different types of dll classes as long as the dll class
	interface conforms to the dll interface specified in
	(project dllclass.prj).

	You control the type of DLL class by the DLLname you specify
	when constructing the class. (see constructor in dllobje.cpp)

*/
class DLLobject  {
    public:
    HANDLE  hDLL;           // DLL handle

    CONSTRUCTOR xcon;       // DLL interface functions
    MESSAFUNCTION xmessa;
    DESTRUCTOR xdest;
    
    void far *xthis;        // DLL class instance this pointer
    
    char DLLname[80];
    int Status;             // Status of class (optional)

    DLLobject(char *xDLLname,UINT message,WPARAM wParam,LPARAM lParam);
    ~DLLobject();
    long SendMessage(UINT message,WPARAM wParam,LPARAM lParam);
    };
#endif
